function [gewinn,loesung] = rucksack(b,y, b0)

% loest Rucksackproblem mit dynamischer Programmierung
% b - Gewichtsvektor mit Gewicht der Objekte
% y - Vektor mit Werten der Objekte
% b0 - maximale Rucksackkapazitaet

m = numel(b);
F = zeros(b0+1,m+1); % Achtung: Matrix soll auch Informationen zu F(0,0) 
                     % bzw. F(0,.), F(,0) enthalten
V = zeros(b0+1,m+1); % Vorgaenger zum Merken der Reihenfolge

for k_bar = 1:m
    for b_bar = 1:b(k_bar)
        F(b_bar, k_bar+1) = % ergaenze
        V(b_bar, k_bar+1) = % ergaenze
    end
    
    for b_bar = b(k_bar):b0
        p = % erster Wert aus Maximumsbildung, ergaenze
        q = % zweiter Wert aus Maximumsbildung, ergaenze
        
        if p >= q
            F(b_bar+1,k_bar+1) = % ergaenze
            V(b_bar+1,k_bar+1) = % ergaenze
        else
            F(b_bar+1,k_bar+1) = % ergaenze
            V(b_bar+1,k_bar+1) = % ergaenze
        end
    end
end

%F
%V

% Erzeuge die Loesung

b_bar = b0;
k_bar = m;
loesung = [];
while k_bar > 0
    if V(b_bar+1,k_bar+1) == k_bar
        b_bar = b_bar - b(k_bar);
        loesung = [k_bar,loesung];
    else
        k_bar = V(b_bar+1, k_bar+1);
    end
end

gewinn = F(b0+1,m+1);